/**
 * Framework7 6.0.0-alpha.1
 * Full featured mobile HTML framework for building iOS & Android apps
 * https://framework7.io/
 *
 * Copyright 2014-2020 Vladimir Kharlampidi
 *
 * Released under the MIT License
 *
 * Released on: August 7, 2020
 */

import Template7 from 'template7';
import $ from './utils/dom7';
import Framework7 from './components/app/app-class';
import request from './utils/request';
import * as utils from './utils/utils';
import { getSupport } from './utils/get-support';
import { getDevice } from './utils/get-device';
import DeviceModule from './modules/device/device';
import SupportModule from './modules/support/support';
import UtilsModule from './modules/utils/utils';
import ResizeModule from './modules/resize/resize';
import RequestModule from './modules/request/request';
import TouchModule from './modules/touch/touch';
import ClicksModule from './modules/clicks/clicks';
import RouterModule from './modules/router/router';
import RouterTemplateLoaderModule from './modules/router/template-loader';
import RouterComponentLoaderModule from './modules/router/component-loader';
import ComponentModule, { Component } from './modules/component/component';
import HistoryModule from './modules/history/history';
import ServiceWorkerModule from './modules/service-worker/service-worker';
import Statusbar from './components/statusbar/statusbar';
import View from './components/view/view';
import Navbar from './components/navbar/navbar';
import Toolbar from './components/toolbar/toolbar';
import Subnavbar from './components/subnavbar/subnavbar';
import TouchRipple from './components/touch-ripple/touch-ripple';
import Modal from './components/modal/modal';
import Router from './modules/router/router-class';
Framework7.prototype.t7 = Template7;
Framework7.Template7 = Template7;
Router.use([RouterTemplateLoaderModule, RouterComponentLoaderModule]);
Framework7.use([DeviceModule, SupportModule, UtilsModule, ResizeModule, RequestModule, TouchModule, ClicksModule, RouterModule, HistoryModule, ComponentModule, ServiceWorkerModule, Statusbar, View, Navbar, Toolbar, Subnavbar, TouchRipple, Modal]);
export { Template7, Component, $ as Dom7, request, utils, getDevice, getSupport };
export default Framework7;
